package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.ProductPrice;
import com.izouma.awesomeadmin.service.ProductPriceService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/productPrice")
@RequiresAuthentication
public class ProductPriceController {

    @Autowired
    private ProductPriceService productPriceService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(ProductPrice record) {
        List<ProductPrice> pp = productPriceService.getProductPriceList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getProductPrice", method = RequestMethod.GET)
    @ResponseBody
    public Result getProductPrice(@RequestParam(required = false, value = "id") String id) {
        ProductPrice data = productPriceService.getProductPriceById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(ProductPrice record) {
        ProductPrice data = productPriceService.getProductPrice(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, ProductPrice record) {
        Map<String, Object> result = new HashMap<>();

        List<ProductPrice> pp =productPriceService.getProductPriceByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(ProductPrice record) {
        boolean num = productPriceService.createProductPrice(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateProductPrice(ProductPrice record) {
        boolean num = productPriceService.updateProductPrice(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteProductPrice(@RequestParam(required = true, value = "id") String id) {

        boolean num = productPriceService.deleteProductPrice(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, ProductPrice record) throws Exception {

    List<ProductPrice> productPrices = productPriceService.getProductPriceList(record);


        String sheetName = "product_price";
        String titleName = "商品价格数据表";
        String fileName = "商品价格表";
        int columnNumber = 14;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "商品" ,   "名称" ,   "价格" ,   "类型" ,   "最小数量" ,   "最大数量" ,   "库存" ,   "备注"  };
        String[][] dataList = new String[productPrices.size()][14];

        for (int i = 0; i < productPrices.size(); i++) {

                        dataList[i][0] = String.valueOf(productPrices.get(i).getId());
                        dataList[i][1] = String.valueOf(productPrices.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(productPrices.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(productPrices.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(productPrices.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(productPrices.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(productPrices.get(i).getProductId());
                        dataList[i][7] = String.valueOf(productPrices.get(i).getName());
                        dataList[i][8] = String.valueOf(productPrices.get(i).getPrice());
                        dataList[i][9] = String.valueOf(productPrices.get(i).getTypeFlag());
                        dataList[i][10] = String.valueOf(productPrices.get(i).getMinCounts());
                        dataList[i][11] = String.valueOf(productPrices.get(i).getMaxCounts());
                        dataList[i][12] = String.valueOf(productPrices.get(i).getInventory());
                        dataList[i][13] = String.valueOf(productPrices.get(i).getRemark());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

